local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')

function OnPopulate()
  ScenarioUtils.InitializeArmies()
  ScenarioInfo.Options.Victory = 'eradication'
end

function OnStart(self)
  for index,ARMY in ListArmies() do
    AddBuildRestriction(ARMY,categories.ueb2101)
    AddBuildRestriction(ARMY,categories.urb2101)
    AddBuildRestriction(ARMY,categories.uab2101)
    AddBuildRestriction(ARMY,categories.ueb0102)
    AddBuildRestriction(ARMY,categories.urb0102)
    AddBuildRestriction(ARMY,categories.uab0102)
    AddBuildRestriction(ARMY,categories.ueb0103)
    AddBuildRestriction(ARMY,categories.urb0103)
    AddBuildRestriction(ARMY,categories.uab0103)
    AddBuildRestriction(ARMY,categories.ueb2303)
    AddBuildRestriction(ARMY,categories.urb2303)
    AddBuildRestriction(ARMY,categories.uab2303)
    AddBuildRestriction(ARMY,categories.ueb2301)
    AddBuildRestriction(ARMY,categories.urb2301)
    AddBuildRestriction(ARMY,categories.uab2301)
    AddBuildRestriction(ARMY,categories.ueb2108)
    AddBuildRestriction(ARMY,categories.urb2108)
    AddBuildRestriction(ARMY,categories.uab2108)
    AddBuildRestriction(ARMY,categories.uel0304)
    AddBuildRestriction(ARMY,categories.url0304)
    AddBuildRestriction(ARMY,categories.ual0304)
    AddBuildRestriction(ARMY,categories.ueb2302)
    AddBuildRestriction(ARMY,categories.urb2302)
    AddBuildRestriction(ARMY,categories.uab2302)
    AddBuildRestriction(ARMY,categories.ueb2401)
    AddBuildRestriction(ARMY,categories.url0401)
    AddBuildRestriction(ARMY,categories.uaa0310)
    AddBuildRestriction(ARMY,categories.ues0401)
    AddBuildRestriction(ARMY,categories.ura0401)
    AddBuildRestriction(ARMY,categories.uas0401)
  end
  
  local marker1 = nil
  
  for i,army in ListArmies() do
    marker1 = ScenarioUtils.GetMarker('SPIDER_' .. army)['position']
    unit = CreateUnitHPR('ual0401', army, marker1[1], marker1[2], marker1[3], 0,0,0)
    unit:SetCustomName('The Queen')
    unit:SetMaxHealth(10000)
    unit:SetHealth(nil,10000)
    unit:SetSpeedMult(0)
    unit:AddOnKilledCallback(
      function(self)
        GetArmyBrain(getArmyName(self)):OnDefeat()
      end)
  end

end


--given a unit return an army
function getArmyName(unit)
	local unitArmy = unit
	if unit.GetArmy then
		unitArmy = unit:GetArmy()
	end
	
	return ListArmies()[unitArmy]
end

